package ru.dbotthepony.kstarbound.defs.world

import com.google.gson.GsonBuilder
import ru.dbotthepony.kstarbound.io.KTypeAdapter
import ru.dbotthepony.kvector.vector.Color
import kotlin.properties.Delegates

class WorldProperties {
	var nonCombat = false

	fun immutable(): ImmutableWorldProperties {
		return ImmutableWorldProperties(
			nonCombat = nonCombat
		)
	}

	companion object {
		val ADAPTER = KTypeAdapter(::WorldProperties,
			WorldProperties::nonCombat,
		)

		fun registerGson(gsonBuilder: GsonBuilder) {
			gsonBuilder.registerTypeAdapter(WorldProperties::class.java, ADAPTER)
		}
	}
}

class ImmutableWorldProperties(
	val nonCombat: Boolean
)
